Index: uspace/lib/ieee80211/src/ieee80211.c
===================================================================
--- uspace/lib/ieee80211/src/ieee80211.c	(revision 59fa7ab26f7b4336f753dcd52b89d6cac0dfca97)
+++ uspace/lib/ieee80211/src/ieee80211.c	(revision 1dcc0b9aaf9f79f759ef62cc27bccd9e6b7c8d80)
@@ -494,33 +844,683 @@
 }
 
+/** 
+ * IEEE 802.11 association implementation.
+ * 
+ * @param ieee80211_dev Pointer to IEEE 802.11 device structure.
+ * @param password Passphrase to be used in encrypted communication or NULL
+ * for open networks.
+ * 
+ * @return EOK if succeed, negative error code otherwise.
+ */
+int ieee80211_associate(ieee80211_dev_t *ieee80211_dev, char *password) 
+{
+	nic_t *nic = nic_get_from_ddf_dev(ieee80211_dev->ddf_dev);
+	nic_address_t nic_address;
+	nic_query_address(nic, &nic_address);
+	
+	ieee80211_scan_result_link_t *auth_link =
+		ieee80211_dev->bssid_info.res_link;
+	
+	ieee80211_scan_result_t *auth_data = &auth_link->scan_result;
+	
+	size_t ssid_data_size = str_size(auth_data->ssid);
+	
+	size_t payload_size = 
+		sizeof(ieee80211_ie_header_t) * 3 +
+		ssid_data_size + 
+		IEEE80211_DATA_RATES_SIZE + 
+		IEEE80211_EXT_DATA_RATES_SIZE;
+	
+	size_t buffer_size = 
+		sizeof(ieee80211_mgmt_header_t) + 
+		sizeof(ieee80211_assoc_req_body_t) +
+		payload_size;
+	
+	if(auth_data->security.type == IEEE80211_SECURITY_WPA2) {
+		buffer_size += auth_link->rsn_copy_len;
+	}
+	
+	void *buffer = malloc(buffer_size);
+	memset(buffer, 0, buffer_size);
+	
+	ieee80211_mgmt_header_t *mgmt_header = 
+		(ieee80211_mgmt_header_t *) buffer;
+	
+	mgmt_header->frame_ctrl = host2uint16_t_le(
+		IEEE80211_MGMT_FRAME | 
+		IEEE80211_MGMT_ASSOC_REQ_FRAME
+		);
+	memcpy(mgmt_header->dest_addr, auth_data->bssid.address, ETH_ADDR);
+	memcpy(mgmt_header->src_addr, nic_address.address, ETH_ADDR);
+	memcpy(mgmt_header->bssid, auth_data->bssid.address, ETH_ADDR);
+	
+	ieee80211_assoc_req_body_t *assoc_body =
+		(ieee80211_assoc_req_body_t *) 
+		(buffer + sizeof(ieee80211_mgmt_header_t));
+	assoc_body->listen_interval = host2uint16_t_le(1);
+	
+	/* Jump to payload. */
+	void *it = buffer + sizeof(ieee80211_mgmt_header_t) +
+		sizeof(ieee80211_assoc_req_body_t);
+	ieee80211_prepare_ie_header(&it, IEEE80211_SSID_IE, 
+		ssid_data_size, (void *) auth_data->ssid);
+	ieee80211_prepare_ie_header(&it, IEEE80211_RATES_IE, 
+		IEEE80211_DATA_RATES_SIZE, 
+		(void *) &ieee80211bg_data_rates);
+	ieee80211_prepare_ie_header(&it, IEEE80211_EXT_RATES_IE, 
+		IEEE80211_EXT_DATA_RATES_SIZE, 
+		(void *) &ieee80211bg_data_rates[IEEE80211_DATA_RATES_SIZE]);
+	
+	if(auth_data->security.type != IEEE80211_SECURITY_OPEN) {
+		assoc_body->capability |= host2uint16_t_le(CAP_SECURITY);
+	}
+	
+	if(auth_data->security.type == IEEE80211_SECURITY_WPA2) {
+		memcpy(it, auth_link->rsn_copy,	auth_link->rsn_copy_len);
+	}
+	
+	ieee80211_dev->ops->tx_handler(ieee80211_dev, buffer, buffer_size);
+	
+	/* 
+	 * Save password and SSID to be used in eventual authentication 
+	 * handshake. 
+	 */
+	memcpy(ieee80211_dev->bssid_info.password, password, 
+		str_size(password));
+	
+	free(buffer);
+	
+	return EOK;
+}
+
+/** 
+ * IEEE 802.11 deauthentication implementation.
+ * 
+ * @param ieee80211_dev Pointer to IEEE 802.11 device structure.
+ * 
+ * @return EOK if succeed, negative error code otherwise.
+ */
+int ieee80211_deauthenticate(ieee80211_dev_t *ieee80211_dev)
+{
+	ieee80211_scan_result_t *auth_data =
+		&ieee80211_dev->bssid_info.res_link->scan_result;
+	
+	ieee80211_dev->current_auth_phase = IEEE80211_AUTH_DISCONNECTED;
+	ieee80211_dev->bssid_info.aid = (uint16_t) -1;
+	memcpy(auth_data->bssid.address, ieee80211_broadcast_mac_addr, 
+		ETH_ADDR);
+	
+	nic_t *nic = nic_get_from_ddf_dev(ieee80211_dev->ddf_dev);
+	nic_address_t nic_address;
+	nic_query_address(nic, &nic_address);
+	
+	size_t buffer_size = sizeof(ieee80211_mgmt_header_t) + 
+		sizeof(ieee80211_deauth_body_t);
+	void *buffer = malloc(buffer_size);
+	memset(buffer, 0, buffer_size);
+	
+	ieee80211_mgmt_header_t *mgmt_header = 
+		(ieee80211_mgmt_header_t *) buffer;
+	
+	mgmt_header->frame_ctrl = host2uint16_t_le(
+		IEEE80211_MGMT_FRAME | 
+		IEEE80211_MGMT_DEAUTH_FRAME
+		);
+	memcpy(mgmt_header->dest_addr, auth_data->bssid.address, ETH_ADDR);
+	memcpy(mgmt_header->src_addr, nic_address.address, ETH_ADDR);
+	memcpy(mgmt_header->bssid, auth_data->bssid.address, ETH_ADDR);
+	
+	ieee80211_dev->ops->tx_handler(ieee80211_dev, buffer, buffer_size);
+	
+	free(buffer);
+	
+	ieee80211_dev->ops->bssid_change(ieee80211_dev);
+	
+	return EOK;
+}
+
+static void ieee80211_process_auth_info(ieee80211_scan_result_link_t *ap_data,
+	void *buffer)
+{
+	uint8_t *it = (uint8_t *) buffer;
+	
+	uint16_t *version = (uint16_t *) it;
+	if(uint16_t_le2host(*version) != 0x1) {
+		ap_data->scan_result.security.type = -1;
+		return;
+	}
+	
+	it += sizeof(uint16_t);
+	
+	uint32_t group_cipher = *(it+3);
+	switch(group_cipher) {
+		case IEEE80211_AUTH_CIPHER_TKIP:
+			ap_data->scan_result.security.group_alg =
+				IEEE80211_SECURITY_SUITE_TKIP;
+			break;
+		case IEEE80211_AUTH_CIPHER_CCMP:
+			ap_data->scan_result.security.group_alg =
+				IEEE80211_SECURITY_SUITE_CCMP;
+			break;
+		default:
+			ap_data->scan_result.security.group_alg = -1;
+	}
+	
+	it += 4*sizeof(uint8_t);
+	
+	uint16_t *pairwise_count = (uint16_t *) it;
+	uint32_t pairwise_cipher = *(it+sizeof(uint16_t)+3);
+	switch(pairwise_cipher) {
+		case IEEE80211_AUTH_CIPHER_TKIP:
+			ap_data->scan_result.security.pair_alg =
+				IEEE80211_SECURITY_SUITE_TKIP;
+			break;
+		case IEEE80211_AUTH_CIPHER_CCMP:
+			ap_data->scan_result.security.pair_alg =
+				IEEE80211_SECURITY_SUITE_CCMP;
+			break;
+		default:
+			ap_data->scan_result.security.pair_alg = -1;
+	}
+	
+	it += 2*sizeof(uint16_t) + 
+		uint16_t_le2host(*pairwise_count)*sizeof(uint32_t);
+	
+	uint32_t auth_suite = *(it+3);
+	switch(auth_suite) {
+		case IEEE80211_AUTH_AKM_PSK:
+			ap_data->scan_result.security.auth =
+				IEEE80211_SECURITY_AUTH_PSK;
+			break;
+		case IEEE80211_AUTH_AKM_8021X:
+			ap_data->scan_result.security.auth =
+				IEEE80211_SECURITY_AUTH_8021X;
+			break;
+		default:
+			ap_data->scan_result.security.auth = -1;
+	}
+}
+
+static uint32_t uint32_from_uint8_seq(uint8_t *seq)
+{
+	return (*seq << 24) + (*(seq+1) << 16) + (*(seq+2) << 8) + *(seq+3); 
+}
+
+static uint8_t *ieee80211_process_ies(ieee80211_dev_t *ieee80211_dev,
+	ieee80211_scan_result_link_t *ap_data, void *buffer, size_t buffer_size)
+{
+	void *it = buffer;
+	while((it + sizeof(ieee80211_ie_header_t)) < buffer + buffer_size) {
+		ieee80211_ie_header_t *ie_header = 
+			(ieee80211_ie_header_t *) it;
+		uint8_t *channel;
+		switch(ie_header->element_id) {
+			case IEEE80211_CHANNEL_IE:
+				channel = (uint8_t *) 
+					(it + sizeof(ieee80211_ie_header_t));
+				ap_data->scan_result.channel = *channel;
+				break;
+			case IEEE80211_RSN_IE:
+				if(!ap_data)
+					break;
+				ap_data->scan_result.security.type =
+					IEEE80211_SECURITY_WPA2;
+				ieee80211_process_auth_info(ap_data, 
+					it + sizeof(ieee80211_ie_header_t));
+				ap_data->rsn_copy_len = ie_header->length +
+					sizeof(ieee80211_ie_header_t);
+				memcpy(ap_data->rsn_copy, 
+					it, 
+					ap_data->rsn_copy_len);
+				break;
+			case IEEE80211_VENDOR_IE:
+				if(uint32_from_uint8_seq(it + 
+					sizeof(ieee80211_ie_header_t)) ==
+					WPA_OUI) {
+					if(ap_data->scan_result.security.type ==
+						IEEE80211_SECURITY_WPA2) {
+						break;
+					}
+					ap_data->scan_result.security.type =
+						IEEE80211_SECURITY_WPA;
+					ieee80211_process_auth_info(ap_data,
+						it + 
+						sizeof(ieee80211_ie_header_t) +
+						sizeof(uint32_t));
+				} else if(uint32_from_uint8_seq(it + 
+					sizeof(ieee80211_ie_header_t)) ==
+					GTK_OUI) {
+					return it + 
+						sizeof(ieee80211_ie_header_t) +
+						sizeof(uint32_t) + 2;
+				}
+		}
+		it += sizeof(ieee80211_ie_header_t) + ie_header->length;
+	}
+	
+	return NULL;
+}
+
 /**
  * Process probe response and store results.
  * 
  * @param ieee80211_dev Pointer to IEEE 802.11 device structure.
+ * @param mgmt_header Pointer to start of management frame header.
  * 
  * @return EOK if succeed, negative error code otherwise.
  */
 static int ieee80211_process_probe_response(ieee80211_dev_t *ieee80211_dev, 
+	ieee80211_mgmt_header_t *mgmt_header, size_t buffer_size)
+{
+	ieee80211_beacon_start_t *beacon_body = (ieee80211_beacon_start_t *) 
+		((void *)mgmt_header + sizeof(ieee80211_mgmt_header_t));
+	
+	ieee80211_ie_header_t *ssid_ie_header = (ieee80211_ie_header_t *) 
+		((void *)beacon_body + sizeof(ieee80211_beacon_start_t));
+	
+	/* Not empty SSID. */
+	if(ssid_ie_header->length > 0) {
+		fibril_mutex_t *scan_mutex = &ieee80211_dev->ap_list.scan_mutex;
+		
+		fibril_mutex_lock(scan_mutex);
+		
+		ieee80211_scan_result_list_t *result_list =
+			&ieee80211_dev->ap_list;
+		
+		uint8_t *ssid_start = (uint8_t *) ((void *)ssid_ie_header + 
+			sizeof(ieee80211_ie_header_t));
+		char ssid[IEEE80211_MAX_SSID_LENGTH];
+		memcpy(ssid, ssid_start, ssid_ie_header->length);
+		ssid[ssid_ie_header->length] = '\0';
+		
+		/* Check whether SSID is already in results. */
+		ieee80211_scan_result_list_foreach(*result_list, result) {
+			if(!str_cmp(ssid, result->scan_result.ssid)) {
+				result->last_beacon = time(NULL);
+				fibril_mutex_unlock(scan_mutex);
+				return EOK;
+			}
+		}
+		
+		/* Results are full. */
+		if(result_list->size == IEEE80211_MAX_RESULTS_LENGTH - 1) {
+			fibril_mutex_unlock(scan_mutex);
+			return EOK;
+		}
+		
+		ieee80211_scan_result_link_t *ap_data = 
+			malloc(sizeof(ieee80211_scan_result_link_t));
+		memset(ap_data, 0, sizeof(ieee80211_scan_result_link_t));
+		link_initialize(&ap_data->link);
+		
+		memcpy(ap_data->scan_result.bssid.address, 
+			mgmt_header->bssid, ETH_ADDR);
+		memcpy(ap_data->scan_result.ssid, ssid, 
+			ssid_ie_header->length + 1);
+		
+		if(uint16_t_le2host(beacon_body->capability) & CAP_SECURITY) {
+			ap_data->scan_result.security.type = 
+				IEEE80211_SECURITY_WEP;
+		} else {
+			ap_data->scan_result.security.type = 
+				IEEE80211_SECURITY_OPEN;
+			ap_data->scan_result.security.auth = -1;
+			ap_data->scan_result.security.pair_alg = -1;
+			ap_data->scan_result.security.group_alg = -1;
+		}
+		
+		void *rest_ies_start = ssid_start + ssid_ie_header->length;
+		size_t rest_buffer_size = 
+			buffer_size - 
+			sizeof(ieee80211_mgmt_header_t) -
+			sizeof(ieee80211_beacon_start_t) -
+			sizeof(ieee80211_ie_header_t) -
+			ssid_ie_header->length;
+		
+		ieee80211_process_ies(ieee80211_dev, ap_data, rest_ies_start, 
+			rest_buffer_size);
+		
+		ap_data->last_beacon = time(NULL);
+		
+		ieee80211_scan_result_list_append(result_list, ap_data);
+		
+		fibril_mutex_unlock(scan_mutex);
+	}
+	
+	return EOK;
+}
+
+/**
+ * Process authentication response.
+ * 
+ * @param ieee80211_dev Pointer to IEEE 802.11 device structure.
+ * @param mgmt_header Pointer to start of management frame header.
+ * 
+ * @return EOK if succeed, negative error code otherwise.
+ */
+static int ieee80211_process_auth_response(ieee80211_dev_t *ieee80211_dev,
 	ieee80211_mgmt_header_t *mgmt_header)
 {
-	ieee80211_ie_header_t *ssid_ie_header = (ieee80211_ie_header_t *) 
-		((void *)mgmt_header + sizeof(ieee80211_mgmt_header_t) + 
-		sizeof(ieee80211_beacon_start_t));
-	
-	if(ssid_ie_header->length > 0) {
-		uint8_t *results_length = &ieee80211_dev->ap_list.length;
-		
-		ieee80211_scan_result_t *ap_data = 
-			&ieee80211_dev->ap_list.results[(*results_length)++];
-		
-		memset(ap_data, 0, sizeof(ieee80211_scan_result_t));
-		
-		uint8_t *ssid_start = (uint8_t *) 
-			((void *)ssid_ie_header + 
-			sizeof(ieee80211_ie_header_t));
-
-		memcpy(ap_data->bssid.address, mgmt_header->bssid, ETH_ADDR);
-		memcpy(ap_data->ssid, ssid_start, ssid_ie_header->length);
-		ap_data->ssid[ssid_ie_header->length] = '\0';
+	fibril_mutex_lock(&ieee80211_dev->gen_mutex);
+	
+	ieee80211_dev->current_auth_phase = IEEE80211_AUTH_AUTHENTICATED;
+	
+	fibril_condvar_signal(&ieee80211_dev->gen_cond);
+	fibril_mutex_unlock(&ieee80211_dev->gen_mutex);
+	
+	return EOK;
+}
+
+/**
+ * Process association response.
+ * 
+ * @param ieee80211_dev Pointer to IEEE 802.11 device structure.
+ * @param mgmt_header Pointer to start of management frame header.
+ * 
+ * @return EOK if succeed, negative error code otherwise.
+ */
+static int ieee80211_process_assoc_response(ieee80211_dev_t *ieee80211_dev,
+	ieee80211_mgmt_header_t *mgmt_header)
+{
+	ieee80211_scan_result_t *auth_data =
+		&ieee80211_dev->bssid_info.res_link->scan_result;
+	
+	fibril_mutex_lock(&ieee80211_dev->gen_mutex);
+	
+	ieee80211_assoc_resp_body_t *assoc_resp =
+		(ieee80211_assoc_resp_body_t *) ((void *)mgmt_header +
+		sizeof(ieee80211_mgmt_header_t));
+	
+	ieee80211_dev->bssid_info.aid = uint16_t_le2host(assoc_resp->aid);
+	memcpy(auth_data->bssid.address, mgmt_header->bssid, ETH_ADDR);
+	
+	ieee80211_dev->current_auth_phase = IEEE80211_AUTH_ASSOCIATED;
+	
+	ieee80211_dev->ops->bssid_change(ieee80211_dev);
+	
+	fibril_condvar_signal(&ieee80211_dev->gen_cond);
+	fibril_mutex_unlock(&ieee80211_dev->gen_mutex);
+	
+	return EOK;
+}
+
+static int ieee80211_process_4way_handshake(ieee80211_dev_t *ieee80211_dev,
+	void *buffer, size_t buffer_size)
+{
+	ieee80211_eapol_key_frame_t *key_frame = 
+		(ieee80211_eapol_key_frame_t *) buffer;
+	
+	bool handshake_done = false;
+		
+	ieee80211_scan_result_link_t *auth_link =
+		ieee80211_dev->bssid_info.res_link;
+
+	ieee80211_scan_result_t *auth_data = &auth_link->scan_result;
+	uint8_t *ptk = ieee80211_dev->bssid_info.ptk;
+	uint8_t *gtk = ieee80211_dev->bssid_info.gtk;
+
+	size_t ptk_key_length, gtk_key_length;
+	hash_func_t hash_sel;
+	switch(auth_data->security.pair_alg) {
+		case IEEE80211_SECURITY_SUITE_CCMP:
+			ptk_key_length = IEEE80211_PTK_CCMP_LENGTH;
+			hash_sel = HASH_SHA1;
+			break;
+		default:
+			return ENOTSUP;
+	}
+
+	switch(auth_data->security.group_alg) {
+		case IEEE80211_SECURITY_SUITE_CCMP:
+			gtk_key_length = IEEE80211_GTK_CCMP_LENGTH;
+			break;
+		default:
+			return ENOTSUP;
+	}
+
+	size_t output_size = 
+		sizeof(eth_header_t) +
+		sizeof(ieee80211_eapol_key_frame_t);
+
+	if(!(uint16_t_be2host(key_frame->key_info) & 
+		IEEE80211_EAPOL_KEY_KEYINFO_SECURE)) {
+		output_size += auth_link->rsn_copy_len;
+	}
+
+	nic_t *nic = nic_get_from_ddf_dev(ieee80211_dev->ddf_dev);
+	nic_address_t nic_address;
+	nic_query_address(nic, &nic_address);
+
+	void *output_buffer = malloc(output_size);
+	memset(output_buffer, 0, output_size);
+
+	/* Setup ethernet header. */
+	eth_header_t *eth_header = (eth_header_t *) output_buffer;
+	memcpy(eth_header->dest_addr, auth_data->bssid.address,	ETH_ADDR);
+	memcpy(eth_header->src_addr, nic_address.address, ETH_ADDR);
+	eth_header->proto = host2uint16_t_be(ETH_TYPE_PAE);
+
+	ieee80211_eapol_key_frame_t *output_key_frame =
+		(ieee80211_eapol_key_frame_t *) 
+		(output_buffer + sizeof(eth_header_t));
+
+	/* Copy content of incoming EAPOL-Key frame. */
+	memcpy((void *) output_key_frame, buffer, 
+		sizeof(ieee80211_eapol_key_frame_t));
+
+	output_key_frame->proto_version = 0x1;
+	output_key_frame->key_length = 0;
+	output_key_frame->body_length =
+		host2uint16_t_be(output_size - sizeof(eth_header_t)-4);
+	output_key_frame->key_info &= 
+		~host2uint16_t_be(
+			IEEE80211_EAPOL_KEY_KEYINFO_ACK
+		);
+
+	/* 
+	 * Check if it is last or first incoming message in 4-way 
+	 * handshake. 
+	 */
+	if(uint16_t_be2host(key_frame->key_info) & 
+		IEEE80211_EAPOL_KEY_KEYINFO_SECURE) {
+		output_key_frame->key_info &= 
+			~host2uint16_t_be(
+				IEEE80211_EAPOL_KEY_KEYINFO_ENCDATA
+			);
+		output_key_frame->key_info &= 
+			~host2uint16_t_be(
+				IEEE80211_EAPOL_KEY_KEYINFO_INSTALL
+			);
+		output_key_frame->key_data_length = 0;
+		output_key_frame->key_length = 0;
+		memset(output_key_frame->key_nonce, 0, 32);
+		memset(output_key_frame->key_mic, 0, 16);
+		memset(output_key_frame->key_rsc, 0, 8);
+		memset(output_key_frame->eapol_key_iv, 0, 16);
+
+		/* Derive GTK and save it. */
+		uint16_t key_data_length = 
+			uint16_t_be2host(key_frame->key_data_length);
+		uint16_t decrypt_len = key_data_length - 8;
+		uint8_t key_data[decrypt_len];
+		uint8_t *data_ptr = (uint8_t *) (buffer + 
+			sizeof(ieee80211_eapol_key_frame_t));
+		if(ieee80211_aes_key_unwrap(ptk + KEK_OFFSET, data_ptr,
+			key_data_length, key_data) == EOK) {
+			
+			uint8_t *key_ptr = ieee80211_process_ies(ieee80211_dev, 
+				NULL, key_data, decrypt_len);
+
+			if(key_ptr) {
+				memcpy(gtk, key_ptr, gtk_key_length);
+				handshake_done = true;
+			}
+		}
+	} else {
+		output_key_frame->key_info |= 
+			host2uint16_t_be(
+				IEEE80211_EAPOL_KEY_KEYINFO_MIC
+			);
+		output_key_frame->key_data_length =
+			host2uint16_t_be(auth_link->rsn_copy_len);
+		memcpy((void *)output_key_frame + 
+			sizeof(ieee80211_eapol_key_frame_t),
+			auth_link->rsn_copy,
+			auth_link->rsn_copy_len);
+
+		/* Compute PMK. */
+		uint8_t pmk[PBKDF2_KEY_LENGTH];
+		pbkdf2((uint8_t *) ieee80211_dev->bssid_info.password,
+			str_size(ieee80211_dev->bssid_info.password),
+			(uint8_t *) auth_data->ssid,
+			str_size(auth_data->ssid), pmk, hash_sel);
+
+		uint8_t *anonce = key_frame->key_nonce;
+
+		/* Generate SNONCE. */
+		uint8_t snonce[32];
+		rnd_sequence(snonce, 32);
+
+		memcpy(output_key_frame->key_nonce, snonce, 32);
+
+		uint8_t *dest_addr = eth_header->dest_addr;
+		uint8_t *src_addr = eth_header->src_addr;
+
+		/* Derive PTK and save it. */
+		uint8_t prf_result[ptk_key_length];
+		uint8_t crypt_data[PRF_CRYPT_DATA_LENGTH];
+		memcpy(crypt_data, 
+			min_sequence(dest_addr, src_addr, ETH_ADDR), 
+			ETH_ADDR);
+		memcpy(crypt_data + ETH_ADDR, 
+			max_sequence(dest_addr, src_addr, ETH_ADDR), 
+			ETH_ADDR);
+		memcpy(crypt_data + 2*ETH_ADDR, 
+			min_sequence(anonce, snonce, 32), 
+			32);
+		memcpy(crypt_data + 2*ETH_ADDR + 32, 
+			max_sequence(anonce, snonce, 32),
+			32);
+		ieee80211_prf(pmk, crypt_data, prf_result, hash_sel);
+		memcpy(ptk, prf_result, ptk_key_length);
+	}
+
+	/* Compute MIC of key frame data from KCK part of PTK. */
+	uint8_t mic[SHA1_HASH_LENGTH];
+	hmac(ptk, 16, (uint8_t *) output_key_frame, 
+		output_size - sizeof(eth_header_t), mic, hash_sel);
+
+	memcpy(output_key_frame->key_mic, mic, 16);
+
+	ieee80211_send_frame(nic, output_buffer, output_size);
+
+	free(output_buffer);
+
+	if(handshake_done) {
+		/* Insert keys into device. */
+		
+		/* Pairwise key. */
+		ieee80211_key_config_t key_config;
+		key_config.suite = auth_data->security.pair_alg;
+		key_config.flags =
+			IEEE80211_KEY_FLAG_TYPE_PAIRWISE;
+		memcpy(key_config.data, 
+			ptk + TK_OFFSET,
+			ptk_key_length - TK_OFFSET);
+
+		ieee80211_dev->ops->key_config(ieee80211_dev,
+			&key_config, true);
+		
+		/* Group key. */
+		key_config.suite = auth_data->security.group_alg;
+		key_config.flags =
+			IEEE80211_KEY_FLAG_TYPE_GROUP;
+		memcpy(key_config.data, gtk, gtk_key_length);
+
+		ieee80211_dev->ops->key_config(ieee80211_dev,
+			&key_config, true);
+
+		/* Signal successful handshake completion. */
+		fibril_mutex_lock(&ieee80211_dev->gen_mutex);
+		fibril_condvar_signal(&ieee80211_dev->gen_cond);
+		fibril_mutex_unlock(&ieee80211_dev->gen_mutex);
+	}
+	
+	return EOK;
+}
+
+static int ieee80211_process_eapol_frame(ieee80211_dev_t *ieee80211_dev,
+	void *buffer, size_t buffer_size)
+{
+	ieee80211_eapol_key_frame_t *key_frame = 
+		(ieee80211_eapol_key_frame_t *) buffer;
+	if(ieee80211_is_eapol_key_frame(key_frame)) {
+		return ieee80211_process_4way_handshake(ieee80211_dev, buffer,
+			buffer_size);
+	}
+	
+	return EOK;
+}
+
+/**
+ * Process data frame.
+ * 
+ * @param ieee80211_dev Pointer to IEEE 802.11 device structure.
+ * @param buffer Data buffer starting with IEEE 802.11 data header.
+ * @param buffer_size Size of buffer.
+ * 
+ * @return EOK if succeed, negative error code otherwise.
+ */
+static int ieee80211_process_data(ieee80211_dev_t *ieee80211_dev, 
+	void *buffer, size_t buffer_size)
+{
+	ieee80211_data_header_t *data_header = 
+		(ieee80211_data_header_t *) buffer;
+	
+	if(ieee80211_has_data_frame(data_header->frame_ctrl)) {
+		nic_t *nic = nic_get_from_ddf_dev(ieee80211_dev->ddf_dev);
+		size_t strip_length = sizeof(ieee80211_data_header_t) + 
+			ARRAY_SIZE(rfc1042_header);
+		
+		/* TODO: Probably different by used security alg. */
+		if(ieee80211_is_encrypted_frame(data_header->frame_ctrl)) {
+			strip_length += 8;
+		}
+		
+		/* Process 4-way authentication handshake. */
+		uint16_t *proto = (uint16_t *) (buffer + strip_length);
+		if(uint16_t_be2host(*proto) == ETH_TYPE_PAE) {
+			return ieee80211_process_eapol_frame(ieee80211_dev,
+				buffer + strip_length + sizeof(uint16_t),
+				buffer_size - strip_length - sizeof(uint16_t));
+		}
+		
+		/* Note: ETH protocol ID is already there, so we don't create 
+		 * whole ETH header. */
+		size_t frame_size = 
+			buffer_size - strip_length + sizeof(eth_header_t)-2;
+		nic_frame_t *frame = nic_alloc_frame(nic, frame_size);
+
+		if(frame == NULL) {
+			return ENOMEM;
+		}
+
+		uint8_t *src_addr = 
+			ieee80211_is_fromds_frame(data_header->frame_ctrl) ?
+				data_header->address3 : data_header->address2;
+		uint8_t *dest_addr = 
+			ieee80211_is_tods_frame(data_header->frame_ctrl) ?
+				data_header->address3 : data_header->address1;
+
+		eth_header_t *eth_header =
+			(eth_header_t *) frame->data;
+		memcpy(eth_header->src_addr, src_addr, ETH_ADDR);
+		memcpy(eth_header->dest_addr, dest_addr, ETH_ADDR);
+
+		memcpy(frame->data + sizeof(eth_header_t)-2, 
+			buffer + strip_length, 
+			buffer_size - strip_length);
+
+		nic_received_frame(nic, frame);
 	}
 	
@@ -548,19 +1548,19 @@
 			ieee80211_is_beacon_frame(mgmt_header->frame_ctrl)) {
 			return ieee80211_process_probe_response(ieee80211_dev,
+				mgmt_header, buffer_size);
+		}
+		
+		if(ieee80211_is_auth_frame(mgmt_header->frame_ctrl)) {
+			return ieee80211_process_auth_response(ieee80211_dev,
 				mgmt_header);
 		}
-		// TODO
+		
+		if(ieee80211_is_assoc_response_frame(mgmt_header->frame_ctrl)) {
+			return ieee80211_process_assoc_response(ieee80211_dev,
+				mgmt_header);
+		}
 	} else if(ieee80211_is_data_frame(frame_ctrl)) {
-		nic_t *nic = nic_get_from_ddf_dev(ieee80211_dev->ddf_dev);
-		size_t frame_size = buffer_size - sizeof(ieee80211_data_header_t);
-		nic_frame_t *frame = nic_alloc_frame(nic, frame_size); 
-		if (frame != NULL) {
-			memcpy(frame->data, 
-				buffer + sizeof(ieee80211_data_header_t), 
-				frame_size);
-			nic_received_frame(nic, frame);
-		}
-	} else {
-		// TODO
+		return ieee80211_process_data(ieee80211_dev, buffer, 
+			buffer_size);
 	}
 	
Index: uspace/lib/ieee80211/src/ieee80211_iface_impl.c
===================================================================
--- uspace/lib/ieee80211/src/ieee80211_iface_impl.c	(revision 59fa7ab26f7b4336f753dcd52b89d6cac0dfca97)
+++ uspace/lib/ieee80211/src/ieee80211_iface_impl.c	(revision 1dcc0b9aaf9f79f759ef62cc27bccd9e6b7c8d80)
@@ -27,5 +27,5 @@
  */
 
-#include <stdio.h>
+#include <str.h>
 #include <errno.h>
 
@@ -42,31 +42,181 @@
  */
 
+/**
+ * Implementation of fetching scan results.
+ * 
+ * @param fun Device function.
+ * @param results Structure where should be stored scan results.
+ * 
+ * @return EOK. 
+ */
 int ieee80211_get_scan_results_impl(ddf_fun_t *fun, 
-	ieee80211_scan_results_t *results)
+	ieee80211_scan_results_t *results, bool now)
 {
 	nic_t *nic_data = nic_get_from_ddf_fun(fun);
 	ieee80211_dev_t *ieee80211_dev = nic_get_specific(nic_data);
 	
+	if(!ieee80211_is_ready(ieee80211_dev))
+		return EREFUSED;
+	
+	fibril_mutex_lock(&ieee80211_dev->ap_list.scan_mutex);
+	time_t scan_span = time(NULL) - ieee80211_dev->ap_list.last_scan;
+	fibril_mutex_unlock(&ieee80211_dev->ap_list.scan_mutex);
+	
+	if(now || scan_span > MAX_SCAN_SPAN_SEC) {
+		ieee80211_dev->ops->scan(ieee80211_dev);
+	}
+	
+	fibril_mutex_lock(&ieee80211_dev->ap_list.scan_mutex);
 	if(results) {
-		memcpy(results, &ieee80211_dev->ap_list, 
-			sizeof(ieee80211_scan_results_t));
-	}
+		ieee80211_scan_result_list_t *result_list =
+			&ieee80211_dev->ap_list;
+		
+		int i = 0;
+		ieee80211_scan_result_list_foreach(*result_list, result) {
+			memcpy(&results->results[i], 
+				&result->scan_result, 
+				sizeof(ieee80211_scan_result_t));
+			i++;
+		}
+		
+		results->length = i;
+	}
+	fibril_mutex_unlock(&ieee80211_dev->ap_list.scan_mutex);
 	
 	return EOK;
 }
 
-int ieee80211_connect_impl(ddf_fun_t *fun, char *ssid, char *password)
-{
-	assert(ssid);
+static uint16_t ieee80211_channel_to_freq(uint8_t channel)
+{
+	return IEEE80211_CHANNEL_GAP * (channel - 1) + IEEE80211_FIRST_FREQ;
+}
+
+/**
+ * Working procedure of connect function.
+ * 
+ * @param ieee80211_dev Pointer to IEEE 802.11 device.
+ * @param auth_data Selected AP data we want to connect to.
+ * 
+ * @return EOK if everything OK, ETIMEOUT when timeout during authenticating.
+ */
+static int ieee80211_connect_proc(ieee80211_dev_t *ieee80211_dev,
+	ieee80211_scan_result_link_t *auth_data, char *password)
+{
+	int rc;
+	
+	ieee80211_dev->bssid_info.res_link = auth_data;
+	
+	/* Set channel. */
+	rc = ieee80211_dev->ops->set_freq(ieee80211_dev, 
+		ieee80211_channel_to_freq(auth_data->scan_result.channel));
+	if(rc != EOK)
+		return rc;
+	
+	/* Try to authenticate. */
+	ieee80211_authenticate(ieee80211_dev);
+	fibril_mutex_lock(&ieee80211_dev->gen_mutex);
+	rc = fibril_condvar_wait_timeout(&ieee80211_dev->gen_cond,
+			&ieee80211_dev->gen_mutex,
+			AUTH_TIMEOUT);
+	fibril_mutex_unlock(&ieee80211_dev->gen_mutex);
+	if(rc != EOK)
+		return rc;
+	if(ieee80211_dev->current_auth_phase != IEEE80211_AUTH_AUTHENTICATED)
+		return EINVAL;
+	
+	/* Try to associate. */
+	ieee80211_associate(ieee80211_dev, password);
+	fibril_mutex_lock(&ieee80211_dev->gen_mutex);
+	rc = fibril_condvar_wait_timeout(&ieee80211_dev->gen_cond,
+			&ieee80211_dev->gen_mutex,
+			AUTH_TIMEOUT);
+	fibril_mutex_unlock(&ieee80211_dev->gen_mutex);
+	if(rc != EOK)
+		return rc;
+	if(ieee80211_dev->current_auth_phase != IEEE80211_AUTH_ASSOCIATED)
+		return EINVAL;
+	
+	/* On open network, we are finished. */
+	if(auth_data->scan_result.security.type == IEEE80211_SECURITY_OPEN)
+		return EOK;
+	
+	/* Otherwise wait for 4-way handshake to complete. */
+	fibril_mutex_lock(&ieee80211_dev->gen_mutex);
+	rc = fibril_condvar_wait_timeout(&ieee80211_dev->gen_cond,
+			&ieee80211_dev->gen_mutex,
+			HANDSHAKE_TIMEOUT);
+	fibril_mutex_unlock(&ieee80211_dev->gen_mutex);
+	if(rc != EOK)
+		return rc;
+	if(ieee80211_dev->current_auth_phase != IEEE80211_AUTH_ASSOCIATED)
+		return EINVAL;
+	
+	return EOK;
+}
+
+/**
+ * Implementation of connecting to specified SSID.
+ * 
+ * @param fun Device function.
+ * @param ssid_start SSID prefix of access point we want to connect to.
+ * 
+ * @return EOK if everything OK, ETIMEOUT when timeout during authenticating,
+ * EINVAL when SSID not in scan results list, EPERM when incorrect password
+ * passed.
+ */
+int ieee80211_connect_impl(ddf_fun_t *fun, char *ssid_start, char *password)
+{
+	assert(ssid_start);
 	assert(password);
 	
-	/*
 	nic_t *nic_data = nic_get_from_ddf_fun(fun);
 	ieee80211_dev_t *ieee80211_dev = nic_get_specific(nic_data);
-	 */
-	
-	// TODO
-	
-	return EOK;
+	
+	if(!ieee80211_is_ready(ieee80211_dev))
+		return EREFUSED;
+	
+	if(ieee80211_is_connected(ieee80211_dev)) {
+		int rc = ieee80211_dev->iface->disconnect(fun);
+		if(rc != EOK)
+			return rc;
+	}
+	
+	fibril_mutex_lock(&ieee80211_dev->ap_list.scan_mutex);
+
+	ieee80211_scan_result_list_foreach(ieee80211_dev->ap_list, result) {
+		if(!str_lcmp(ssid_start, 
+			result->scan_result.ssid, 
+			str_size(ssid_start))) {
+			fibril_mutex_unlock(&ieee80211_dev->ap_list.scan_mutex);
+			return ieee80211_connect_proc(ieee80211_dev, result,
+				password);
+		}
+	}
+	
+	fibril_mutex_unlock(&ieee80211_dev->ap_list.scan_mutex);
+	
+	return EINVAL;
+}
+
+/**
+ * Implementation of disconnecting device from network.
+ * 
+ * @param fun Device function.
+ * 
+ * @return EOK if everything OK, EINVAL when not connected to any network.
+ */
+int ieee80211_disconnect_impl(ddf_fun_t *fun)
+{
+	nic_t *nic_data = nic_get_from_ddf_fun(fun);
+	ieee80211_dev_t *ieee80211_dev = nic_get_specific(nic_data);
+	
+	if(!ieee80211_is_ready(ieee80211_dev))
+		return EREFUSED;
+	
+	if(!ieee80211_is_connected(ieee80211_dev)) {
+		return EINVAL;
+	} else {
+		return ieee80211_deauthenticate(ieee80211_dev);
+	}
 }
 
